<?xml version="1.0" ?>
<schema xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="urn:magento:framework:Setup/Declaration/Schema/etc/schema.xsd">
    <table comment="xcoding_review_rating table" engine="innodb" name="xcoding_review_rating" resource="default">
        <column comment="Entity Id" identity="true" name="id" nullable="false" padding="6" unsigned="true" xsi:type="int"/>
        <constraint referenceId="PRIMARY" xsi:type="primary">
            <column name="id"/>
        </constraint>
        <column xsi:type="bigint" name="review_id" padding="20" unsigned="true" nullable="false" comment="Review ID"/>
        <column name="product_id" nullable="false" xsi:type="int" padding="10" unsigned="true" />
        <column xsi:type="int" name="customer_id" padding="10" unsigned="true" nullable="true" identity="false"
                comment="Customer Id"/>
        <column length="255" name="size_value" xsi:type="varchar"/>
        <column length="255" name="quality_value" xsi:type="varchar"/>
        <column length="255" name="comfort_value" xsi:type="varchar"/>
        <column length="255" name="recommended_value" xsi:type="varchar"/>
        <column name="remote_ip" nullable="false" length="16" comment="Customer IP" xsi:type="varchar" />
        <column name="remote_ip_long" padding="20" unsigned="false" nullable="false" identity="false"
                default="0" comment="Customer IP converted to long integer format" xsi:type="bigint"/>
        <constraint xsi:type="foreign" referenceId="XC_REVIEW_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID" table="xcoding_review_rating"
                    column="customer_id" referenceTable="customer_entity" referenceColumn="entity_id"
                    onDelete="SET NULL"/>
        <constraint xsi:type="foreign" referenceId="XCODING_REVIEW_RATING_ID_REVIEW_REVIEW_ID" table="xcoding_review_rating"
                    column="review_id" referenceTable="review" referenceColumn="review_id" onDelete="CASCADE"/>
        <constraint xsi:type="foreign" referenceId="XCODING_REVIEW_RATING_PRODUCT_ID_PRODUCT_ENTITY_ENTITY_ID"
                    table="xcoding_review_rating" column="product_id" referenceTable="catalog_product_entity"
                    referenceColumn="entity_id" onDelete="CASCADE"/>
        <index referenceId="XC_REVIEW_REVIEW_ID" indexType="btree">
            <column name="review_id"/>
        </index>
        <index referenceId="XC_REVIEW_PRODUCT_ID" indexType="btree">
            <column name="product_id"/>
        </index>
        <index referenceId="XC_REVIEW_CUSTOMER_ID" indexType="btree">
            <column name="customer_id"/>
        </index>
    </table>
    <table comment="xcoding_review_rating_aggregated Table" engine="innodb" name="xcoding_review_rating_aggregated" resource="default">
        <column comment="Primary ID" identity="true" name="id" nullable="false" padding="6" unsigned="true" xsi:type="int"/>
        <constraint referenceId="PRIMARY" xsi:type="primary">
            <column name="id"/>
        </constraint>
        <column name="product_id" nullable="false" xsi:type="int" padding="10" unsigned="true" />
        <column comment="Rating code (column in xcoding_review_rating table)" name="code" nullable="false" length="255" xsi:type="varchar"/>
        <column default="0" name="value_count" nullable="false" xsi:type="int"/>
        <column name="value" nullable="false" xsi:type="varchar" length="255"/>
        <constraint xsi:type="foreign" referenceId="XCODING_REVIEW_RATING_AGGREGATED_PRODUCT_ID_PRODUCT_ENTITY_ENTITY_ID"
                    table="xcoding_review_rating_aggregated" column="product_id" referenceTable="catalog_product_entity"
                    referenceColumn="entity_id" onDelete="CASCADE"/>
        <constraint xsi:type="unique" referenceId="XCODING_REVIEW_RATING_AGGREGATED_UNIQUE">
            <column name="product_id"/>
            <column name="code"/>
            <column name="value"/>
        </constraint>
        <index referenceId="XC_REVIEW_AGGREGATED_PRODUCT_ID" indexType="btree">
            <column name="product_id"/>
        </index>
    </table>
    <table name="review_detail" resource="default" engine="innodb" comment="Review detail information">
        <column xsi:type="boolean" name="product_bought" nullable="false" default="false"/>
    </table>
</schema>